<?php
/**
 * ezchat.roomajx.inc
 *
 * @package Cotonti
 * @version 0.1.0
 * @author 2basix.nl
 * @copyright Copyright (c) 2basix.nl 2010-2011
 * @license BSD
 */

  
(defined('SED_CODE')) or die('Wrong URL.');

$ajxreturn = '';
$chatitems = $db_x.'chatitm';
$chatrooms = $db_x.'chatrooms';

// comes from additional data (JS on screen)
$nlastscreenid = sed_import('lastchatid','G','INT');
$maxitems = sed_import('maxitems','G','INT');
$rm=sed_import('n','G','TXT');



$auth_A = sed_auth('plug', 'ezchat', 'A');

if ($a=='submit')
{
	$auth = sed_auth('plug', 'ezchat', 'W');
	if ($auth==FALSE) {
		$ajxreturn .= '{"submitstatus" : "error", "submitmessage" : "'.$L['ezc_rightsnowrite'].'"}';
		echo $ajxreturn;
		return;
	}
	
	//$nlastchat = sed_import('lastchatid','G','INT');
	$chatinput = sed_import('chatinput','P','TXT');
	$aliasnm = sed_import('alias','P','STX');
	
	//======================================
	//==--  check form data  --==
	//======================================
	//check submitted room
	$rsql = sed_sql_query("SELECT cr_id FROM $chatrooms WHERE cr_id=$rm");
	$found=sed_sql_numrows($rsql);
	if ($found==0) {
		$ajxreturn .= '{"submitstatus" : "error", "submitmessage" : "'.$L['ezc_invalidroom'].'" }';
		echo $ajxreturn;
		return;
	}

	if ((int)$usr['id']>0) {
		$usrname=$usr['name'];
	} else {
		$usrname=sed_sql_prep($aliasnm);
	}

	if (trim($chatinput)!="" && $usrname!="") {
		//insert the data (chatitem) into the table
		$sql = sed_sql_query("INSERT INTO $chatitems (
								ci_userid,
								ci_username,	
								ci_rmid,
								ci_itemtime,
								ci_text)
								VALUES
								(".(int)$usr['id'].",
								'".$usrname."',
								'".(int)$rm."',
								".(int)$sys['now_offset'].",
								'".sed_sql_prep($chatinput)."')");

		$ajxreturn = '{"submitstatus" : "ok", "submitmessage" : "'.$L['ezc_chatitemadded'].'" ';
	} else {
		$ajxreturn = '{"submitstatus" : "error", "submitmessage" : "'.$L['ezc_chatitemignored'].'" ';
	}
}

if ($a=='deleteid')
{
	$ndeleteid = sed_import('id','G','INT');
	if ($auth_A && $ndeleteid>0) {
		$sql = sed_sql_query("DELETE FROM $chatitems WHERE ci_id=".$ndeleteid);	
		// het zou de laatste entry kunnen zijn
		$nlastscreenid="0";		
	}
}

/*========================================
	Allways get the chatitems !!!
============================================*/
	// 	NO LASTCHAT!
		//get all return data (chatitmes since lastchat) including this post
		// return it as JSON notation start with an ,
		//isql = sed_sql_query("SELECT * FROM $chatitems WHERE ci_id>".$nlastscreenid." AND ci_room='$room' LIMIT $maxitems");

	//TTD: checken op order (oudste boven !!, nu id, maar misschien op ci_itemtime)


// Check Reading rights
$auth = sed_auth('plug', 'ezchat', 'R');
if ($auth==FALSE) {
	$ajxreturn = '{"nrchatitems":"0","chatmessage":"'.$L['ezc_rightsnoread'].'"}';
	echo $ajxreturn;
	return;
}

if ($ajxreturn=="") {
	// there was NO submit, so start here with chatitems !
	$ajxreturn='{';
} else {
	$ajxreturn.=',';		// continue with chatitems
}

// screen data volume regelen !
$lastid = 0;

if ($maxitems=="") {
	$maxitems=$cfg['plugin']['ezchat']['ezc_nritems'];
}	

// ci_rmid not needed !! so leave it out !! (this saves data traffic)
$isql = sed_sql_query("SELECT ci_id,ci_userid,ci_username,ci_itemtime,ci_text FROM $chatitems WHERE ci_rmid=$rm ORDER BY ci_id DESC LIMIT ".$maxitems);
$numrows = sed_sql_numrows($isql);

if($numrows > 0) {
	// query return to JSON
	$tmpjson="";
	while($irow = sed_sql_fetchassoc($isql)) {
		$tmpjson .= '"id'.$irow['ci_id'].'":'.json_encode($irow).',';
		if ((int)$irow['ci_id'] > $lastid) {
			$lastid=(int)$irow['ci_id'];
		}
	}
	if ($lastid>(int)$nlastscreenid) {
		$ajxreturn .= '"nrchatitems":"'.$numrows.'"';
		$tmpjson="{".substr($tmpjson,0,-1)."}";
	} else {
		// no new items so send no data back
		$ajxreturn .= '"nrchatitems":"0"';
		$tmpjson="{}";
	}	
	// see: http://www.php.net/manual/en/function.json-encode.php
	$ajxreturn .= ',"chatmessage":""';
	$ajxreturn .= ',"usrid":"'.$usr['id'].'"'; 
	$ajxreturn .= ',"admin":"'.$auth_A.'"'; 
	// deze data is voor debug
	$ajxreturn .= ',"chatlastscreenid":"'.$nlastscreenid.'"';
	$ajxreturn .= ',"chatlastid":"'.$lastid.'"';
	$ajxreturn .= ',"chatitems":'.$tmpjson;
} else {
	$ajxreturn .= '"nrchatitems":"-1"';
	// no data to return
	$ajxreturn .= ',"chatmessage":"'.$L['ezc_nomessages'].'"';
}
$ajxreturn .= '}';
echo $ajxreturn


?>