<?php
/**
 * ezchat.room.inc
 *
 * @package Cotonti
 * @version 0.1.0
 * @author 2basix.nl
 * @copyright Copyright (c) 2basix.nl 2010-2011
 * @license BSD
 */

(defined('SED_CODE')) or die('Wrong URL.');


//http://www.php.net/manual/en/function.urlencode.php
function utf16_urlencode ( $str ) {
        # convert characters > 255 into HTML entities
        $convmap = array( 0xFF, 0x2FFFF, 0, 0xFFFF );
        $str = mb_encode_numericentity( $str, $convmap, "UTF-8");

        # escape HTML entities, so they are not urlencoded
        $str = preg_replace( '/&#([0-9a-fA-F]{2,5});/i', 'mark\\1mark', $str );
        $str = urlencode($str);

        # now convert escaped entities into unicode url syntax
        $str = preg_replace( '/mark([0-9a-fA-F]{2,5})mark/i', '%u\\1', $str );
        return $str;
    }

	
/* ===============================
		Screen section
================================== */	
$errors="";
$roomname = "";
$roomid = "";
$chatrooms = $db_x.'chatrooms';

$rm=sed_import('n','G','HTM');

//** get the room name
$rsql = sed_sql_query("SELECT cr_id,cr_room FROM $chatrooms WHERE cr_id=$rm");
$found=sed_sql_numrows($rsql);
if ($found==0) {
	$errors="Error: ".$L['ezc_invalidroom'];
	$roomname = "unknown";
	$roomid="-1";
	return;
} else {
	$rrow = sed_sql_fetcharray($rsql);
	$roomname=$rrow['cr_room'];
	$roomid=$rrow['cr_id'];
}


require_once $cfg['plugins_dir']."/ezchat/inc/ezchat.header.php";

$mskin = $cfg['plugins_dir']."/ezchat/tpl/ezchat.".$m.".tpl"; 
$t = new XTemplate($mskin);
$t-> assign(array(
	"EZCHAT_BASEDIR"		=>	$cfg['plugins_dir']."/ezchat",
	"EZCHAT_ERRORS"			=>	$errors,
	"EZCHAT_INPUT_ACTION"	=>	"plug.php?r=ezchat&m=roomajx&a=submit&n=".$roomid,
	"EZCHAT_ROOMID"			=>	$roomid,
	"EZCHAT_ROOMNAME"		=>	$roomname,
	"EZCHAT_ROOMNAME_ENC"	=>	utf16_urlencode($roomname),
	"EZCHAT_CRPRESENT"		=>	$L['ezc_crpresent'],
	"EZCHAT_MAXITEMS"		=>	$cfg['plugin']['ezchat']['ezc_nritems'],
	"EZCHAT_CHATHISTORY"	=>	"",
	"EZCHAT_CHATBUTTONS"	=>	""
));

//	"EZCHAT_ROOMNAME"		=>	htmlentities($roomname),


//	"EZCHAT_INPUT_ACTION"	=>	"plug.php?r=ezchat&m=roomajx&n=".$roomname."&a=submit",


$t->parse("MAIN");
$t->out("MAIN");

require_once $cfg['plugins_dir']."/ezchat/inc/ezchat.footer.php";


?>