<?php

/**
 * Global header (FOR EZchat window mode)
 *
 * @package Cotonti
 * @version 0.0.6
 * @author Neocrome, Cotonti Team
 * @copyright Copyright (c) Cotonti Team 2008-2009
 * @license BSD
 */

defined('SED_CODE') or die('Wrong URL');

//sed_uriredir_store();

unset($title_tags, $title_data);
$title_tags[] = array('{MAINTITLE}', '{DESCRIPTION}', '{SUBTITLE}');
$title_tags[] = array('%1$s', '%2$s', '%3$s');
$title_data = array($cfg['maintitle'], $cfg['subtitle'], $out['subtitle']);
$out['fulltitle'] = sed_title('title_header', $title_tags, $title_data);

/** **/
$out['meta_contenttype'] = ($cfg['doctypeid']>2 && $cfg['xmlclient']) ? "application/xhtml+xml" : "text/html";
$out['meta_desc'] = $plug_desc.$cfg['maintitle']." - ".$cfg['subtitle'];
$out['head_head'] = $plug_head;
$out['basehref'] = '<base href="'.$cfg['mainurl'].'/" />';
$out['compopup'] = sed_javascript($morejavascript);

$pluglocation = $cfg['plugins_dir']."/ezchat";

sed_sendheaders();

$mskin = $cfg['plugins_dir']."/ezchat/tpl/ezchat.header.tpl"; 
$t = new XTemplate($mskin);

$t->assign(array (
	"HEADER_DOCTYPE" => $cfg['doctype'],
	"HEADER_META_CONTENTTYPE" => $out['meta_contenttype'],
	"HEADER_META_CHARSET" => $cfg['charset'],
	"HEADER_META_DESCRIPTION" => $out['meta_desc'],
	"HEADER_HEAD" => $out['head_head'],
	"HEADER_BASEHREF" => $out['basehref'],
	"HEADER_COMPOPUP" => $out['compopup'],
	"HEADER_TITLE" => $plug_title.$out['fulltitle'],
	"HEADER_PLUGLOCATION"	=> $pluglocation
));

$t->parse("HEADER");
$t->out("HEADER");

?>