<?php
/**
 * ezchat.roomsel.inc
 *
 * @package Cotonti
 * @version 0.1.0
 * @author 2basix.nl
 * @copyright Copyright (c) 2basix.nl 2010-2011
 * @license BSD
 */

(defined('SED_CODE')) or die('Wrong URL.');

	
/* ===============================
		Room selection section
================================== */	

$chatrooms = $db_x.'chatrooms';
$chatonline = $db_x.'chatonline';

$errors="";
$adminerrors="";
$roomsel = "<option>".$L['ezc_nodata']."</option>";
$basedir=$cfg['plugins_dir']."/ezchat";
$ezc_admin = sed_auth('plug', 'ezchat', 'A');

/* ======================================
		Take other actions
========================================= */
if ($m=="cleanup") {
	if (ezc_admin) {
		// load admin part
		require_once($cfg['plugins_dir']."/ezchat/inc/ezchat.inc.php");
		$clean_ret=ezc_cleanezchat($cfg['plugin']['ezchat']['ezc_clean']);
		if (!$clean_ret) {$adminerrors.="Cleanup: cleaning error !";}
		else { header("Location: " . SED_ABSOLUTE_URL . sed_url('plug', "e=ezchat", '', true)); }
	} else {
		$adminerrors.="Cleanup: You are not allowed to do that";
	}
}

if ($m=="emptyroom") {
	$rm=sed_import('n','G','STX');
	if ($rm=="") {
		$adminerrors.="emptyroom: No room specified";
	} else {
		if (ezc_admin) {
			// load admin part
			require_once($cfg['plugins_dir']."/ezchat/inc/ezchat.inc.php");
			$empty_ret=ezc_emptyroom((int)$rm);
			if (!$empty_ret) {$adminerrors.="emptyroom: Error !"; }
			else { header("Location: " . SED_ABSOLUTE_URL . sed_url('plug', "e=ezchat", '', true)); }
		} else { $adminerrors.="emptyroom: You are not allowed to do that";	}
	}
}


if ($m=="delroom") {
	$rm=sed_import('n','G','STX');
	if ($rm=="") {
		$adminerrors.="deleteroom: No room specified";
	} else {
		if (ezc_admin) {
			// load admin part
			require_once($cfg['plugins_dir']."/ezchat/inc/ezchat.inc.php");
			$clean_ret=ezc_deleteroom((int)$rm);
			if (!$clean_ret) {$adminerrors.="deleteroom: delete room error !"; }
			else { header("Location: " . SED_ABSOLUTE_URL . sed_url('plug', "e=ezchat", '', true)); }
		} else { $adminerrors.="deleteroom: You are not allowed to do that";	}
	}
}

if ($m=="addroom" && $a=='submit') {
	if (ezc_admin) {
		$room = sed_import('roomname','P','HTM');
		// load admin part
		require_once($cfg['plugins_dir']."/ezchat/inc/ezchat.inc.php");
		$add_ret=ezc_addroom($room);
		if (!$add_ret) {$adminerrors.="addroom: Error !"; }
		else { header("Location: " . SED_ABSOLUTE_URL . sed_url('plug', "e=ezchat", '', true)); }
	} else { $adminerrors.="addroom: You are not allowed to do that";}	
}


//** get the rooms
$rsql = sed_sql_query("SELECT cr_id,cr_room FROM $chatrooms ORDER BY cr_room ASC");
$found=sed_sql_numrows($rsql);
if ($found==0) {
	$errors=$L['ezc_norooms'];
} else {
	$roomsel="";
	$roomlist="";
	while($rrow = sed_sql_fetcharray($rsql)) {
		// walk through the rooms
		$xy=trim($rrow['cr_room']);
		$pq=(string)$rrow['cr_id'];
		$roomsel .= "<option value=\"$pq\">".$xy."</option>\n";

		//===============================
		//==-- Count users in room
		$tim=time()-61;
		$sq="SELECT co_rmid FROM ".$chatonline." WHERE co_rmid=".$pq." AND co_itemtime>".$tim.";";
		$rcsql = sed_sql_query($sq);
		$found=sed_sql_numrows($rcsql);
		$number=' &nbsp; &nbsp; # '.$found.' Online';
		//===============================
		$roomlist .= '<a style="font-size:130%" href="#xanchor" title="'.$L['ezc_open'].': '.$xy.'" alt="" onclick="openroom(\''.$pq.'\'); return false;"><img style="vertical-align:middle;" src="'.$basedir.'/img/megaphone32Go.png" />&nbsp; &nbsp; &nbsp;'.$xy.'</a>'.$number.'<br />';
	}
}

//$mskin = $cfg['plugins_dir']."/ezchat/tpl/ezchat.roomsel.tpl"; 
$t = new XTemplate(sed_skinfile('ezchat.roomsel', true));
$t-> assign(array(
	"EZCHAT_BASEDIR"		=>	$basedir,
	"EZCHAT_BASEURL"		=>	"plug.php?e=ezchat",
	"EZCHAT_ERRORS"			=>	$errors,
	"EZCHAT_ADMINERRORS"	=>	$adminerrors,
	"EZCHAT_ROOMSELECTION"	=>	$roomsel,
	"EZCHAT_ROOMLIST"		=>	$roomlist,
	"EZCHAT_ADMIN"			=>	($ezc_admin)?"true":"false",
	"EZCHAT_ROOMNUM"		=>	$found
));

$t->parse("MAIN.EZCHATSEL");







?>